import { PoolClient, QueryConfig } from 'pg';
import { QueryBuilder, Actionable, NotificationListener, PaginatedQueryBuilder } from './interfaces';
export declare class DataService {
    private config;
    private poolConfig;
    private notificationClient;
    private dataPool;
    private queryBuilders;
    private paginatedQueryBuilders;
    private actions;
    private notificationListeners;
    constructor();
    connect(): Promise<void>;
    registerNotificationListener(notificationListener: NotificationListener): void;
    registerQueryBuilder(queryBuilders: QueryBuilder[]): void;
    registerPaginatedQueryBuilder(paginatedQqueryBuilders: PaginatedQueryBuilder[]): void;
    query(query: string, queryParams: any, user?: any): Promise<any[]>;
    paginatedSizeQuery(query: string, queryParams: any, user?: any): Promise<any[]>;
    paginatedQuery(query: string, queryParams: any, offset: number, limit: number, user?: any): Promise<any[]>;
    giveDbClient(): Promise<PoolClient>;
    stop(): Promise<void>;
    registerModelActions(models: Actionable[]): void;
    act(address: string, actionParams: any, user?: any): Promise<any>;
    actInMyTransaction(client: PoolClient, address: string, actionParams: any, user?: any): Promise<any>;
}
export declare function iterateOnQuery(client: PoolClient, query: QueryConfig, chunkSize: number, arrayMode?: boolean): AsyncGenerator<import("pg").QueryArrayResult<any[]>, void, unknown>;
export declare const syncLogApiBody: (request: any, server: any, src: any) => Promise<any>;
